///////////////////////////////////////////////////////////////////////////////
/*
    Title:    Blinking LED
    Author:   Andrzej Okrutny
    Date:     9/2007
    Purpose:  -
    needed
    Software: AVR-GCC
    needed
    Hardware: ATtiny 13
    Note:     To contact me, mail to anok@ceti.pl
              www.anok.ceti.pl
*/
///////////////////////////////////////////////////////////////////////////////

// OSC freq
#define F_CPU (9600000)

#include <avr/io.h>
#include <util/delay.h>


#define LED_DDR  DDRB
#define LED_PORT PORTB
#define LED_BIT  PB3


#define MAX_DELAY (262.14/(F_CPU/1E6))


#define Delay( delay_in_ms ) \
{ \
\
  const u16_t count = delay_in_ms / (u16_t) MAX_DELAY; \
  const u16_t rest  = delay_in_ms % (u16_t) MAX_DELAY; \
  u16_t i; \
\
  for( i = 0; i < count; ++i ) { \
    _delay_ms( MAX_DELAY ); \
  } \
\
  _delay_ms( rest );  \
}


typedef unsigned short u16_t;



//*****************************************************************************
//				MAIN
//*****************************************************************************

int main( void )
{

  LED_PORT |= _BV( LED_BIT );
  LED_DDR  |= _BV( LED_BIT );

  for(;;) {
    LED_PORT &= ~ _BV( LED_BIT );  // LED ON
    Delay( 500 );                  // delay 0.5 seconds
    LED_PORT |=  _BV( LED_BIT );   // LED OFF
    Delay( 500 );                  // delay 0.5 seconds
  }

}
